blob: 79f3d1e25638095396d4833ae48c7b648e84f5e5 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Colin Crosse0ef0a82017-07-27 21:29:18 +000048export USE_JACK="false"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070052# If dx was not set by the environment variable, assume it is in the path.
53if [ -z "$DX" ]; then
54 export DX="dx"
55fi
56
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080057# If jasmin was not set by the environment variable, assume it is in the path.
58if [ -z "$JASMIN" ]; then
59 export JASMIN="jasmin"
60fi
61
Andreas Gampe8fda9f22014-10-03 16:15:37 -070062# If smali was not set by the environment variable, assume it is in the path.
63if [ -z "$SMALI" ]; then
64 export SMALI="smali"
65fi
66
67# If dexmerger was not set by the environment variable, assume it is in the path.
68if [ -z "$DXMERGER" ]; then
69 export DXMERGER="dexmerger"
70fi
71
Sebastien Hertz19ac0272015-02-24 17:39:50 +010072# If jack was not set by the environment variable, assume it is in the path.
73if [ -z "$JACK" ]; then
74 export JACK="jack"
75fi
76
Sebastien Hertz19ac0272015-02-24 17:39:50 +010077# ANDROID_BUILD_TOP is not set in a build environment.
78if [ -z "$ANDROID_BUILD_TOP" ]; then
79 export ANDROID_BUILD_TOP=$oldwd
80fi
81
Andreas Gampef47fb2f2016-06-24 22:30:29 -070082# ANDROID_HOST_OUT is not set in a build environment.
83if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080084 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070085fi
86
Sebastien Hertz19ac0272015-02-24 17:39:50 +010087# If JACK_CLASSPATH is not set, assume it only contains core-libart.
88if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010090fi
91
Sebastien Hertz19ac0272015-02-24 17:39:50 +010092export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080093
Igor Murashkine5181932017-06-15 16:03:50 -070094# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070095if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070096 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
97fi
98
Igor Murashkin271a0f82017-02-14 21:14:17 +000099# Zipalign is not on the PATH in some configs, auto-detect it.
100if [ -z "$ZIPALIGN" ]; then
101 if which zipalign >/dev/null; then
102 ZIPALIGN="zipalign";
103 else
104 # TODO: Add a dependency for zipalign in Android.run-test.mk
105 # once it doesn't depend on libandroidfw (b/35246701)
106 case "$OSTYPE" in
107 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
108 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
109 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
110 esac
111 fi
112fi
113export ZIPALIGN
114
jeffhao5d1ac922011-09-29 17:41:15 -0700115info="info.txt"
116build="build"
117run="run"
118expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700119check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700120output="output.txt"
121build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100122cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700123strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700124lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700125testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700126run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000127build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700128
Alex Light91de25f2015-10-28 17:00:06 -0700129quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000130debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700131prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700132target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700133dev_mode="no"
134update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700135debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000136relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800137runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700138usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700139build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700140suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700141trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700142trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700143basic_verify="false"
144gc_verify="false"
145gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700146jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700147jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700148jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700149jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700150strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700151always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700152never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700153have_dex2oat="yes"
154have_patchoat="yes"
155have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800156multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000157android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700158bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800159suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700160# By default we will use optimizing.
161image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000162image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700163
164while true; do
165 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700166 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700167 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100168 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700169 shift
Alex Light91de25f2015-10-28 17:00:06 -0700170 elif [ "x$1" = "x--quiet" ]; then
171 quiet="yes"
172 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700173 elif [ "x$1" = "x--use-java-home" ]; then
174 if [ -n "${JAVA_HOME}" ]; then
175 export JAVA="${JAVA_HOME}/bin/java"
176 export JAVAC="${JAVA_HOME}/bin/javac -g"
177 else
178 echo "Passed --use-java-home without JAVA_HOME variable set!"
179 usage="yes"
180 fi
181 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800182 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700183 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800184 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800185 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700186 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700187 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700188 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100189 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100190 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700191 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700192 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800193 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700194 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700195 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700196 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700197 shift
198 elif [ "x$1" = "x--dalvik" ]; then
199 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800200 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700201 shift
Alex Light03a112d2014-08-25 13:25:56 -0700202 elif [ "x$1" = "x--no-dex2oat" ]; then
203 have_dex2oat="no"
204 shift
205 elif [ "x$1" = "x--no-patchoat" ]; then
206 have_patchoat="no"
207 shift
208 elif [ "x$1" = "x--no-image" ]; then
209 have_image="no"
210 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800211 elif [ "x$1" = "x--multi-image" ]; then
212 multi_image_suffix="-multi"
213 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700214 elif [ "x$1" = "x--pic-test" ]; then
215 run_args="${run_args} --pic-test"
216 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700217 elif [ "x$1" = "x--relocate" ]; then
218 relocate="yes"
219 shift
220 elif [ "x$1" = "x--no-relocate" ]; then
221 relocate="no"
222 shift
223 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100224 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700225 prebuild_mode="yes"
226 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700227 elif [ "x$1" = "x--strip-dex" ]; then
228 run_args="${run_args} --strip-dex"
229 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000230 elif [ "x$1" = "x--debuggable" ]; then
231 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000232 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000233 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700234 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100235 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700236 prebuild_mode="no"
237 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700238 elif [ "x$1" = "x--gcverify" ]; then
239 basic_verify="true"
240 gc_verify="true"
241 shift
242 elif [ "x$1" = "x--gcstress" ]; then
243 basic_verify="true"
244 gc_stress="true"
245 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700246 elif [ "x$1" = "x--jvmti-step-stress" ]; then
247 jvmti_step_stress="true"
248 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700249 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
250 jvmti_redefine_stress="true"
251 shift
Alex Light43e935d2017-06-19 15:40:40 -0700252 elif [ "x$1" = "x--jvmti-field-stress" ]; then
253 jvmti_field_stress="true"
254 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700255 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
256 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700257 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800258 elif [ "x$1" = "x--suspend-timeout" ]; then
259 shift
260 suspend_timeout="$1"
261 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700262 elif [ "x$1" = "x--image" ]; then
263 shift
264 image="$1"
265 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700266 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000267 elif [ "x$1" = "x-Xcompiler-option" ]; then
268 shift
269 option="$1"
270 run_args="${run_args} -Xcompiler-option $option"
271 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000272 elif [ "x$1" = "x--build-option" ]; then
273 shift
274 option="$1"
275 build_args="${build_args} $option"
276 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700277 elif [ "x$1" = "x--runtime-option" ]; then
278 shift
279 option="$1"
280 run_args="${run_args} --runtime-option $option"
281 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700282 elif [ "x$1" = "x--gdb-arg" ]; then
283 shift
284 gdb_arg="$1"
285 run_args="${run_args} --gdb-arg $gdb_arg"
286 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700287 elif [ "x$1" = "x--debug" ]; then
288 run_args="${run_args} --debug"
289 shift
290 elif [ "x$1" = "x--gdb" ]; then
291 run_args="${run_args} --gdb"
292 dev_mode="yes"
293 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700294 elif [ "x$1" = "x--strace" ]; then
295 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700296 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700297 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700298 elif [ "x$1" = "x--zygote" ]; then
299 run_args="${run_args} --zygote"
300 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800301 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000302 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700303 image_suffix="-interpreter"
304 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800305 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700306 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000307 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800308 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700309 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700310 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800311 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700312 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700313 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700314 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700315 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700316 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700317 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700318 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700319 elif [ "x$1" = "x--no-optimize" ]; then
320 run_args="${run_args} --no-optimize"
321 shift
322 elif [ "x$1" = "x--no-precise" ]; then
323 run_args="${run_args} --no-precise"
324 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700325 elif [ "x$1" = "x--invoke-with" ]; then
326 shift
327 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700328 if [ "x$what" = "x" ]; then
329 echo "$0 missing argument to --invoke-with" 1>&2
330 usage="yes"
331 break
332 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700333 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700334 shift
335 elif [ "x$1" = "x--dev" ]; then
336 run_args="${run_args} --dev"
337 dev_mode="yes"
338 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700339 elif [ "x$1" = "x--build-only" ]; then
340 build_only="yes"
341 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100342 elif [ "x$1" = "x--build-with-javac-dx" ]; then
343 USE_JACK="false"
344 shift
345 elif [ "x$1" = "x--build-with-jack" ]; then
346 USE_JACK="true"
347 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700348 elif [ "x$1" = "x--output-path" ]; then
349 shift
350 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700351 if [ "x$tmp_dir" = "x" ]; then
352 echo "$0 missing argument to --output-path" 1>&2
353 usage="yes"
354 break
355 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700356 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000357 elif [ "x$1" = "x--android-root" ]; then
358 shift
359 if [ "x$1" = "x" ]; then
360 echo "$0 missing argument to --android-root" 1>&2
361 usage="yes"
362 break
363 fi
364 android_root="$1"
365 run_args="${run_args} --android-root $1"
366 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700367 elif [ "x$1" = "x--update" ]; then
368 update_mode="yes"
369 shift
370 elif [ "x$1" = "x--help" ]; then
371 usage="yes"
372 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700373 elif [ "x$1" = "x--64" ]; then
374 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700375 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700376 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200377 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700378 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200379 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700380 elif [ "x$1" = "x--stream" ]; then
381 trace_stream="true"
382 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700383 elif [ "x$1" = "x--always-clean" ]; then
384 always_clean="yes"
385 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700386 elif [ "x$1" = "x--never-clean" ]; then
387 never_clean="yes"
388 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800389 elif [ "x$1" = "x--dex2oat-swap" ]; then
390 run_args="${run_args} --dex2oat-swap"
391 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700392 elif [ "x$1" = "x--instruction-set-features" ]; then
393 shift
394 run_args="${run_args} --instruction-set-features $1"
395 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700396 elif [ "x$1" = "x--bisection-search" ]; then
397 bisection_search="yes"
398 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000399 elif [ "x$1" = "x--vdex" ]; then
400 run_args="${run_args} --vdex"
401 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000402 elif [ "x$1" = "x--vdex-filter" ]; then
403 shift
404 filter=$1
405 run_args="${run_args} --vdex-filter $filter"
406 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700407 elif [ "x$1" = "x--random-profile" ]; then
408 run_args="${run_args} --random-profile"
409 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700410 elif [ "x$1" = "x--dex2oat-jobs" ]; then
411 shift
412 run_args="${run_args} -Xcompiler-option -j$1"
413 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700414 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700415 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700416 usage="yes"
417 break
418 else
419 break
420 fi
421done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700422
Alex Light10bc5a42016-05-10 10:01:22 -0700423run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700424# Allocate file descriptor real_stderr and redirect it to the shell's error
425# output (fd 2).
426if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
427 exec {real_stderr}>&2
428else
429 # In bash before version 4.1 we need to do a manual search for free file
430 # descriptors.
431 FD=3
432 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
433 real_stderr=$FD
434 eval "exec ${real_stderr}>&2"
435fi
436if [ "$quiet" = "yes" ]; then
437 # Force the default standard output and error to go to /dev/null so we will
438 # not print them.
439 exec 1>/dev/null
440 exec 2>/dev/null
441fi
442
443function err_echo() {
444 echo "$@" 1>&${real_stderr}
445}
446
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700447# tmp_dir may be relative, resolve.
448#
449# Cannot use realpath, as it does not exist on Mac.
450# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700451# Cannot use readlink -m, as it does not exist on Mac.
452# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700453noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700454tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700455mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700456
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800457# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000458if [ ! "$runtime" = "jvm" ]; then
459 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
460fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800461
Alex Lighte7873ec2014-08-12 09:53:50 -0700462if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800463 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
464 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700465fi
466if [ "$gc_verify" = "true" ]; then
467 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
468fi
469if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700470 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700471fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700472if [ "$jvmti_redefine_stress" = "true" ]; then
473 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
474fi
Alex Lightc38c3692017-06-27 15:45:14 -0700475if [ "$jvmti_step_stress" = "true" ]; then
476 run_args="${run_args} --no-app-image --jvmti-step-stress"
477fi
Alex Light43e935d2017-06-19 15:40:40 -0700478if [ "$jvmti_field_stress" = "true" ]; then
479 run_args="${run_args} --no-app-image --jvmti-field-stress"
480fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700481if [ "$jvmti_trace_stress" = "true" ]; then
482 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700483fi
Jeff Hao85139a32014-07-23 11:52:52 -0700484if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700485 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
486 if [ "$trace_stream" = "true" ]; then
487 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
488 # the ability to analyze the file and just write to /dev/null.
489 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
490 # Enable streaming mode.
491 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
492 else
493 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
494 fi
495elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700496 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700497 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700498fi
499
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700500# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100501# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100502function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100503 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800504 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700505 if [ "x${suffix64}" = "x64" ]; then
506 target_arch_name=${grep64bit}
507 else
508 target_arch_name=${grep32bit}
509 fi
510}
511
David Brazdil853a4c32015-09-28 16:15:50 +0100512function guess_host_arch_name() {
513 if [ "x${suffix64}" = "x64" ]; then
514 host_arch_name="x86_64"
515 else
516 host_arch_name="x86"
517 fi
518}
519
Alex Lighta59dd802014-07-02 16:28:08 -0700520if [ "$target_mode" = "no" ]; then
521 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700522 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700523 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700524 exit 1;
525 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700526 fi
527fi
528
Alex Light03a112d2014-08-25 13:25:56 -0700529if [ "$have_patchoat" = "no" ]; then
530 run_args="${run_args} --no-patchoat"
531fi
532
533if [ "$have_dex2oat" = "no" ]; then
534 run_args="${run_args} --no-dex2oat"
535fi
536
Jeff Hao201803f2013-11-20 18:11:39 -0800537if [ ! "$runtime" = "jvm" ]; then
538 run_args="${run_args} --lib $lib"
539fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700540
Jeff Hao201803f2013-11-20 18:11:39 -0800541if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700542 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100543 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800544 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700545 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700546 else
547 true # defaults to using target BOOTCLASSPATH
548 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800549elif [ "$runtime" = "art" ]; then
550 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100551 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000552 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700553 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800554 else
David Brazdil853a4c32015-09-28 16:15:50 +0100555 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800556 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000557 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800558 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700559 if [ "$relocate" = "yes" ]; then
560 run_args="${run_args} --relocate"
561 else
562 run_args="${run_args} --no-relocate"
563 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700564elif [ "$runtime" = "jvm" ]; then
565 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800566 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700567fi
568
Alex Light03a112d2014-08-25 13:25:56 -0700569if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700570 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700571 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700572 exit 1
573 fi
Alex Light03a112d2014-08-25 13:25:56 -0700574 run_args="${run_args} --no-image"
575fi
576
jeffhao5d1ac922011-09-29 17:41:15 -0700577if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700578 err_echo "--dev and --update are mutually exclusive"
579 usage="yes"
580fi
581
582if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
583 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700584 usage="yes"
585fi
586
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700587if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
588 err_echo "--bisection-search and --prebuild are mutually exclusive"
589 usage="yes"
590fi
591
592if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
593 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
594 usage="yes"
595fi
596
597if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
598 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
599 usage="yes"
600fi
601
jeffhao5d1ac922011-09-29 17:41:15 -0700602if [ "$usage" = "no" ]; then
603 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
604 test_dir=`basename "$oldwd"`
605 else
606 test_dir="$1"
607 fi
608
609 if [ '!' -d "$test_dir" ]; then
610 td2=`echo ${test_dir}-*`
611 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700612 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700613 usage="yes"
614 fi
615 test_dir="$td2"
616 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700617 # Shift to get rid of the test name argument. The rest of the arguments
618 # will get passed to the test run.
619 shift
620fi
621
Søren Gjesse620d0a52016-09-19 11:12:51 +0200622# For building with javac and dx always use Java 7. The dx compiler
623# only support byte codes from Java 7 or earlier (class file major
624# version 51 or lower).
625if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
626 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
627fi
628
jeffhao5d1ac922011-09-29 17:41:15 -0700629if [ "$usage" = "yes" ]; then
630 prog=`basename $prog`
631 (
632 echo "usage:"
633 echo " $prog --help Print this message."
634 echo " $prog [options] [test-name] Run test normally."
635 echo " $prog --dev [options] [test-name] Development mode" \
636 "(dumps to stdout)."
637 echo " $prog --update [options] [test-name] Update mode" \
638 "(replaces expected.txt)."
639 echo ' Omitting the test name or specifying "-" will use the' \
640 "current directory."
641 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000642 echo " -O Run non-debug rather than debug build (off by default)."
643 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000644 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000645 echo " --runtime-option Pass an option to the runtime."
646 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000647 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000648 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700649 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000650 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200651 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
652 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000653 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800654 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000655 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000656 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700657 echo " --verify-soft-fail Force soft fail verification (off by default)."
658 echo " Verification is enabled if neither --no-verify"
659 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000660 echo " --no-optimize Turn off optimization (on by default)."
661 echo " --no-precise Turn off precise GC (on by default)."
662 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700663 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000664 echo " other runtime options are ignored."
665 echo " --no-dex2oat Run as though dex2oat was failing."
666 echo " --no-patchoat Run as though patchoat was failing."
667 echo " --prebuild Run dex2oat on the files before starting test. (default)"
668 echo " --no-prebuild Do not run dex2oat on the files before starting"
669 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700670 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000671 echo " --relocate Force the use of relocating in the test, making"
672 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000673 echo " address before running."
674 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700675 echo " --image Run the test using a precompiled boot image. (default)"
676 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000677 echo " --host Use the host-mode virtual machine."
678 echo " --invoke-with Pass --invoke-with option to runtime."
679 echo " --dalvik Use Dalvik (off by default)."
680 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700681 echo " --use-java-home Use the JAVA_HOME environment variable"
682 echo " to find the java compiler and runtime"
683 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000684 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700685 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000686 echo " --64 Run the test in 64-bit mode"
687 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700688 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700689 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000690 echo " --gcstress Run with gc stress testing"
691 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700692 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700693 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700694 echo " --jvmti-redefine-stress"
695 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000696 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700697 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000698 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000699 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700700 echo " --instruction-set-features [string]"
701 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800702 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
703 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700704 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700705 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700706 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000707 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800708 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700709 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700710 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700711 exit 1
712fi
713
714cd "$test_dir"
715test_dir=`pwd`
716
717td_info="${test_dir}/${info}"
718td_expected="${test_dir}/${expected}"
719
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700720if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700721 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700722 exit 1
723fi
724
725if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700726 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700727 exit 1
728fi
729
730# copy the test to a temp dir and run it
731
Elliott Hughes510c8782011-10-06 10:57:34 -0700732echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700733
734rm -rf "$tmp_dir"
735cp -Rp "$test_dir" "$tmp_dir"
736cd "$tmp_dir"
737
738if [ '!' -r "$build" ]; then
739 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800740else
741 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700742fi
743
744if [ '!' -r "$run" ]; then
745 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800746else
747 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700748fi
749
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700750if [ '!' -r "$check_cmd" ]; then
751 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800752else
753 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700754fi
755
jeffhao5d1ac922011-09-29 17:41:15 -0700756chmod 755 "$build"
757chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700758chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700759
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700760export TEST_NAME=`basename ${test_dir}`
761
David Brazdil4846d132015-01-15 19:07:08 +0000762# Tests named '<number>-checker-*' will also have their CFGs verified with
763# Checker when compiled with Optimizing on host.
764if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Igor Murashkin2c7cebd2017-06-26 14:10:02 -0700765 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
Nicolas Geoffrayf654ef92017-06-09 16:31:21 +0100766 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
767 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100768 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100769
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100770 if [ "$target_mode" = "no" ]; then
771 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100772 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100773 else
774 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100775 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100776 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100777
778 if [ "$debuggable" = "yes" ]; then
779 checker_args="$checker_args --debuggable"
780 fi
781
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100782 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100783 -Xcompiler-option -j1"
784 fi
David Brazdil4846d132015-01-15 19:07:08 +0000785 fi
786fi
787
Mathieu Chartier031768a2015-08-27 10:25:02 -0700788 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700789
Richard Uhler020c0f32017-03-14 16:23:17 +0000790# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
791# ART output to approximately 128MB. This should be more than sufficient
792# for any test while still catching cases of runaway output.
793# Set a hard limit to encourage ART developers to increase the ulimit here if
794# needed to support a test case rather than resetting the limit in the run
795# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000796if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000797 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700798fi
799
Igor Murashkin2a337752017-06-16 14:34:40 +0000800if [[ "$target_mode" == "yes" ]]; then
801 build_args="$build_args --target"
802else
803 build_args="$build_args --host"
804fi
805
806if [[ "$dev_mode" == "yes" ]]; then
807 build_args="$build_args --dev"
808fi
809
jeffhao5d1ac922011-09-29 17:41:15 -0700810good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000811good_build="yes"
812good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700813export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700814if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000815 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700816 build_exit="$?"
817 echo "build exit status: $build_exit" 1>&2
818 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800819 echo "${test_dir}: running..." 1>&2
820 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700821 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000822
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800823 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000824 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100825 if [ "$target_mode" = "yes" ]; then
826 adb pull $cfg_output_dir/$cfg_output &> /dev/null
827 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100828 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000829 checker_exit="$?"
830 if [ "$checker_exit" = "0" ]; then
831 good="yes"
832 fi
Alex Light91de25f2015-10-28 17:00:06 -0700833 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000834 else
835 good="yes"
836 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800837 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000838 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700839 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700840elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000841 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700842 build_exit="$?"
843 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800844 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700845 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000846 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100847 if [ "$target_mode" = "yes" ]; then
848 adb pull $cfg_output_dir/$cfg_output &> /dev/null
849 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100850 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000851 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700852 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
853 good="yes"
854 else
Alex Light91de25f2015-10-28 17:00:06 -0700855 cat "$build_output" 1>&${real_stderr} 1>&2
856 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700857 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700858elif [ "$build_only" = "yes" ]; then
859 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000860 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700861 build_exit="$?"
862 if [ "$build_exit" '!=' '0' ]; then
863 cp "$build_output" "$output"
864 echo "build exit status: $build_exit" >>"$output"
865 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
866 if [ "$?" '!=' "0" ]; then
867 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700868 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700869 fi
870 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700871 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700872 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700873 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700874else
David Brazdil4846d132015-01-15 19:07:08 +0000875 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700876 build_exit="$?"
877 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800878 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700879 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000880 run_exit="$?"
881 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700882 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000883 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000884 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100885 if [ "$target_mode" = "yes" ]; then
886 adb pull $cfg_output_dir/$cfg_output &> /dev/null
887 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100888 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000889 checker_exit="$?"
890 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700891 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000892 good_run="no"
893 else
894 good_run="yes"
895 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000896 else
897 good_run="yes"
898 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700899 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000900 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700901 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700902 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
903 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700904 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700905 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700906 max_name_length=$(getconf NAME_MAX ${tmp_dir})
907 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
908 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700909 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700910 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700911 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700912 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000913 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
914 # output == expected
915 good="yes"
916 echo "${test_dir}: succeeded!" 1>&2
917 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700918 fi
919fi
920
jeffhao5d1ac922011-09-29 17:41:15 -0700921(
Alex Lightbfac14a2014-07-30 09:41:21 -0700922 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700923 echo "${test_dir}: FAILED!"
924 echo ' '
925 echo '#################### info'
926 cat "${td_info}" | sed 's/^/# /g'
927 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700928 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700929 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700930 if [ "$strace" = "yes" ]; then
931 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700932 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700933 echo '####################'
934 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700935 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
936 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
937 # tools used by the given ABI work for both x86 and x86-64.
938 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
939 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700940 echo ' '
941 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700942
Alex Light91de25f2015-10-28 17:00:06 -0700943) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700944
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700945# Attempt bisection only if the test failed.
946if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
947 # Bisecting works by skipping different optimization passes which breaks checker assertions.
948 if [ "$run_checker" == "yes" ]; then
949 echo "${test_dir}: not bisecting, checker test." 1>&2
950 else
951 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700952 echo "${test_dir}: bisecting..." 1>&2
953 cwd=`pwd`
954 maybe_device_mode=""
955 raw_cmd=""
956 if [ "$target_mode" = "yes" ]; then
957 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
958 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
959 # to exec in order to preserve pid when calling dalvikvm. This is required
960 # for bisection search to correctly retrieve logs from device.
961 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
962 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
963 maybe_device_mode="--device"
964 raw_cmd="$DEX_LOCATION/cmdline.sh"
965 else
966 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
967 fi
968 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
969 $maybe_device_mode \
970 --raw-cmd="$raw_cmd" \
971 --check-script="$cwd/check" \
972 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700973 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700974 --timeout=300
975 fi
976fi
977
Alex Lightbfac14a2014-07-30 09:41:21 -0700978# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700979if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700980 cd "$oldwd"
981 rm -rf "$tmp_dir"
982 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
983 adb shell rm -rf $DEX_LOCATION
984 fi
985 if [ "$good" = "yes" ]; then
986 exit 0
987 fi
988fi
989
990
991(
992 if [ "$always_clean" = "yes" ]; then
993 echo "${TEST_NAME} files deleted from host "
994 if [ "$target_mode" == "yes" ]; then
995 echo "and from target"
996 fi
997 else
998 echo "${TEST_NAME} files left in ${tmp_dir} on host"
999 if [ "$target_mode" == "yes" ]; then
1000 echo "and in ${DEX_LOCATION} on target"
1001 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001002 fi
1003
Alex Light91de25f2015-10-28 17:00:06 -07001004) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001005
Alex Light6a870fa2016-05-31 16:36:19 -07001006if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1007 exit 0
1008else
1009 exit 1
1010fi